﻿/*:ja
*@plugindesc デバック用
*@author うるふ
*
*@param Start Map
*@desc 最初に始めるマップ番号を入れる
*default 0
*
*@param Start X
*@desc 最初に始める座標Ｘ
*default 0
*
*@param Start Y
*@desc 最初に始める座標Ｙ
*default 0
*
*@param Value1
*@desc 変数代入[代入したい変数；代入したい数値]
*default 1;1
*
*@param Item1
*@desc 入手アイテム[アイテムＩＤ；入手数]
*default 1;1
*
*@param Switch1
*@desc スイッチオン[代入さきスイッチ番号；true or false]
*default 1:true
*
*@param Debug_ON
*@desc デバックスイッチをオンにするかどうか
*default true
*
*@help
*
*デバック用に使用します
*
*Start Map
*最初に始めたいマップ番号を入れるとその場所から始めます
*デフォルト値でタイトルから始めます
*
*
*/



(function() {

   

//Setup

var Parameters = PluginManager.parameters('Debug_Plug');

var startMap = Number(Parameters["Start Map"]);
var startX = Number(Parameters["Start X"]);
var startY = Number(Parameters["Start Y"]);

var valueOne = Parameters["Value1"].split(";");
var itemOne = Parameters["Item1"].split(";");
var switchOne = Parameters["Switch1"].split(";");
var debug_flag = Boolean(Parameters["Debug_ON"] === 'true' || false);


Scene_Boot.prototype.start = function() 
{
        
	Scene_Base.prototype.start.call(this);
        
	SoundManager.preloadImportantSounds();
        
	if (DataManager.isBattleTest()) 
	{
            
		DataManager.setupBattleTest();
            
		SceneManager.goto(Scene_Battle);
        
	} 
	else 
	{

		
           
		this.checkPlayerLocation();
            
		DataManager.setupNewGame(); 
		SceneManager.goto(Scene_Map);
		if(startMap != 0){
			//マップ移動       
 			$gamePlayer.reserveTransfer(startMap,startX,startY,0,0);
			//変数代入
			$gameVariables.setValue(Number(valueOne[0]),Number(valueOne[1]));
			//アイテム入手
			$gameParty.gainItem($dataItems[Number(itemOne[0])],Number(itemOne[1]));
			//スイッチオン現在使用不可
			//if(switchOne[1] == true){
			//$gameSwitches.setValue(Number(switchOne[0]),true);
			//}

			//デバック中のスイッチオン
			$gameSwitches.setValue(20,debug_flag);	
		}
		else
		{
		SceneManager.goto(Scene_Title);         
		}
}
        

this.updateDocumentTitle();


};

})();
