﻿/*:ja
*@plugindesc 船ゲーム
*@author うるふ
*
*@param Unknown Date
*@desc 船ゲーム
*default 不明
*
*@help
*
*船ゲーム
*
*
*
*/



(function() {

   

	//変数
	
	//船アイコンｘ
	var ship_x = 742;

	//ゲージ拡大率
	var water_gage_rate = 25.0;
	//ゲージｙ座標
	var water_gage_y = 0;

	//ゲージトップの座標	
	var water_top_y = 0;

	//ゲージを上昇させるタイミングをカウント
	var gage_up_count = 0;

	//船を進めるパワーの上昇
	var mobil_pwer = 1.5;
	var panic_pwer = 1.5;

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Ship_Game'){

			switch (args[0]){
			case 'start':
				$gameSystem.startShipGame();
				break;
				
			case 'main':
				$gameSystem.mainShipGame();
				break;
			case 'end':
				$gameSystem.endShipGame();
				break;
		
			}
		}

	};
		
	//拡大率からバーの座標を決定
	function Math_gage(){
		
		var gage_long = 300 * water_gage_rate * 0.01;
		water_gage_y = 457 - gage_long / 2 ;
		water_top_y = 457 - gage_long -25 + 50 * water_gage_rate * 0.01;

	}

	

	//ゲームオーバー
	function Game_Over()
	{
		$gameSwitches.setValue(14,true);
	}

	//ゲームクリア
	function Game_Clear()
	{
		$gameSwitches.setValue(13,true);
	}

	//ゲームスタート
	Game_System.prototype.startShipGame = function()
	{

		console.log("start");

		//変数の初期化
		//船アイコンｘ
		ship_x = 742;

		//ゲージ拡大率
		water_gage_rate = 0.0;

		//ゲージを上昇させるタイミングをカウント
		gage_up_count = 0;

		//ゲーム内スイッチの初期化
		for(var i = 13;i<=15;i++)
		{
			$gameSwitches.setValue(i,false);
		}

		

		//モバイルは少しパワーを上げない
		if(Utils.isMobileDevice() == true)
		{
			mobil_pwer = 1.0;
		}
		else
		{
			mobil_pwer = 1.0;
		}
		
		//パニックカード使用でパワーアップ
		if($gameSwitches.value(12) == true)
		{
			panic_pwer = 1.5;
		}
		else
		{
			panic_pwer = 1.0;
		}
		
			

		//下部アイコン描画
		$gameScreen.showPicture(30,"Ship_anderber",1,408,584,100.0,100.0,255,0);
		//$gameScreen.showPicture(31,"Ship_start_icon",1,742,584,100.0,100.0,255,0);
		$gameScreen.showPicture(32,"Ship_goal_icon",1,74,566,100.0,100.0,255,0);
		$gameScreen.showPicture(33,"Ship_ship_icon",1,ship_x,584,100.0,100.0,255,0);

		//拡大率からバーの座標を決定
		Math_gage();		

		//水浸水バー描画
		$gameScreen.showPicture(20,"Ship_water_anderbar",1,751,water_gage_y,100.0,water_gage_rate,255,0);
		$gameScreen.showPicture(21,"Ship_water_topbar",1,751,water_top_y,100.0,100.0,255,0);
		$gameScreen.showPicture(22,"Ship_water_frame",1,751,307,100.0,100.0,255,0);	

		//障害物の表示
		$gameScreen.showPicture(40,"Ship_SeepIrand_icon",1,-50,500,100.0,100.0,255,0);			
		$gameScreen.showPicture(41,"Ship_start_icon",1,-50,500,100.0,100.0,255,0);					

	};

	//ゲームメインメソット
	Game_System.prototype.mainShipGame = function()
	{
		//早送りリセット
		TouchInput._pressedTime = 0;

		//ワンクリックで進む
		if($gameVariables.value(15) == 1)
		{
			//効果音
			AudioManager.playSe({"name":"Magic1","volume":90,"pitch":100,"pan":0});
			
			//船の移動
			ship_x -= 5 * mobil_pwer * panic_pwer ; 
			$gameScreen.movePicture(33,1,ship_x,584,100.0,100.0,255,0,1);

			
			//しま出現
			if(ship_x <= 700 && $gameVariables.value(16) == 0 )
			{
				$gameScreen.movePicture(40,1,900,500,100.0,100.0,255,0,300);
				$gameVariables.setValue(16,1);
			}

			//ふねの出現
			if(ship_x <= 500 && $gameVariables.value(16) == 1 )
			{
				$gameVariables.setValue(16,2);
			}

			//うまの出現
			if(ship_x <= 300 && $gameVariables.value(16) == 2 )
			{
				$gameVariables.setValue(16,3);
			}

			//しま出現
			if(ship_x <= 200 && $gameVariables.value(16) == 3 )
			{
				$gameScreen.movePicture(41,1,900,500,100.0,100.0,255,0,300);
				$gameVariables.setValue(16,4);
			}



			//ヤギの出現
			if(ship_x <= 150 && $gameVariables.value(16) == 4 )
			{
				$gameVariables.setValue(16,5);
			}

			
			if(ship_x <= 74)
			{
				Game_Clear();
			
			}

			

		}

		//ゲージ一定間隔で上昇
		if(++gage_up_count >= 30)
		{
			gage_up_count = 0;

			//ゲージの上昇
			water_gage_rate += 1.5;

			//拡大率からバーの座標を決定
			Math_gage();
			

			$gameScreen.movePicture(20,1,751,water_gage_y,100.0,water_gage_rate,255,0,1);
			$gameScreen.movePicture(21,1,751,water_top_y,100.0,100.0,255,0,1);

			if(water_gage_rate >= 100.0)
			{
				Game_Over();
			}
		
		}
		
		
	};

	Game_System.prototype.endShipGame = function()
	{
		//ピクチャ削除
		$gameScreen.clearPictures();
	};




})();
