﻿/*:ja
*@plugindesc タコ落ち
*@author うるふ
*
*@param Unknown Date
*@desc たこ落ち
*default 不明
*
*@help
*
*たこ落ち
*
*
*
*/



(function() {

  

	//変数/////////////////////////////////////////////

	//タコ焼きの構造体みたいな
	function Tako(x,timing,pix_num)
	{
		this.x = x;
		this.y = -64;
		this.timing = timing;
		this.act = false;
		this.pix_num = pix_num;
	}

	//タコ焼き
	//たこ焼きの数
	var tako_num_max = 20;
	var tako_num = 10;
	

	var tako = new Array(tako_num_max);

	//たこ焼きのオブジェクト作成
	for(var i = 0;i < tako_num_max ; i++)
	{
		tako[i] = new Tako(0,0,0);
	}
	
	var tako_x = 408;
	var tako_y = -64;
	var tako_spd = 9;
	var tako_timing = 0;
	var tako_act = false;

	//タコ出現タイミングマックス
	var timing_max = 40;

	//タコ出現タイミング幅
	var timing_range = 30;

	//たこ焼きのセットｘ座標
	var x_point = new Array();
	
	//座標のセット
	for(var i = 0 ; i < 5 ; i++)
	{
		x_point[i] = 167 * i + 74;
	}	

	//タコをカウントする
	var tako_count = 0;


	var img = "Tako_Ball";

	//カゴ
	var basketa_x = 408;
	var basketa_y = 541;

	//カウント
	var count=0;
	//表示/////////////////////////////////////////////////

	
	//バーの表示
	function Pix_Bar()
	{

		var num = 50;
		var x = 0;
		for(var i = 0 ; i < 4 ; i++)
		{
			x = 147 * (i + 1) + i * 20 + 10;
			$gameScreen.showPicture(num + i,"Tako_Bar", 1, x,312 ,100.0, 100.0, 255, 0);


		
		}

	}

	//バスケットの表示
	function Pix_Baskate()
	{
		$gameScreen.showPicture(30,"Tako_Basketa",1, basketa_x, basketa_y,100.0, 100.0, 255, 0);



	}

	//たこ焼きの表示
	function Pix_Tako()
	{
		for(var i = 0; i < tako_num ; i++)
		{
			$gameScreen.showPicture(tako[i].pix_num,img,1, tako[i].x, tako[i].y,100.0, 100.0, 255, 0);
		}
	}

	///////////////////////////////////////////////////////////////

	//効果音//////////////////////////////////////////////////////

	//効果音の再生（０＝ゲット音、１＝移動、２＝たこ焼き落ちる
	function SE(num)
	{
		switch(num)
		{
		case 0:
			AudioManager.playSe({"name":"Crossbow","volume":90,"pitch":100,"pan":0});
			break;
		case 1:
			AudioManager.playSe({"name":"button08","volume":90,"pitch":100,"pan":0});
			break;
		case 2:
			AudioManager.playSe({"name":"Fall","volume":90,"pitch":100,"pan":0});
			break;

		}
			
	}

	///////////////////////////////////////////////////

	//処理////////////////////////////////////////////////////////

	//初期化
	function Riset()
	{
		//変数の初期化
		count=0;
		tako_num = 10;
		tako_count = 0;
		basketa_x = 408;
		basketa_y = 541;
		tako_spd = 9; 
		count=0;

		$gameVariables.setValue(15,0);

		//たこ焼きの初期化
		for(var i = 0 ; i < tako_num ; i++)
		{
			Tako_Riset(tako,i);
		}
	}

	//たこ焼きのリセット
	function Tako_Riset(tako,num)
	{
		tako[num].timing = Math.floor(Math.random() * timing_range) * timing_max;
		tako[num].x = x_point[Math.floor(Math.random() * 5)];
		tako[num].y = -64;
		tako[num].act = false;
		tako[num].pix_num = num + 1;
		tako_count += 1;
		
		//たこ焼きが一定数出現したら数をどんどん増やしていく
		if(tako_count % 10 == 0)
		{
			//一回スピードアップ
			if(tako_num == 13)
			{
				tako_spd += 12;
				console.log("スピードアップ");
			}
			console.log(tako_num);
			if(tako_num < tako_num_max)
			{
				tako_num += 1;
				console.log(tako_num);
			}
		}
	}

	//カゴを動かす
	function Basketa_Move()
	{

		//右に動かしたときは１、左に動かしたときは２
		var move = 0;
		//１タッチにだけ、trueを返す
		if($gameSystem.wolfOneTouch())
		{
			if(TouchInput.x >= 408)
			{
				move = 1;
			}
			else
			{
				move = 2;
			}
		}

		//キー入力
		if(Input.isTriggered("right"))
		{
			move = 1;
		} 

		if(Input.isTriggered("left"))
		{
			move = 2;
		} 
		
		//動かす
		if(move == 1)
		{
			//効果音
			SE(1);
			if(basketa_x < 742)
			{
				basketa_x += 167;
			}
			move = 0;
		}

		if(move == 2)
		{
			//効果音
			SE(1);
			if(basketa_x > 74)
			{
				basketa_x -= 167;
			}
			move = 0;
		}

	}

	//たこ焼きの取得
	function Tako_Attack(tako,num)
	{
		if(tako[num].x == basketa_x)
		{
			if(basketa_y - tako[num].y < 68 && basketa_y - tako[num].y > 0)
			{

				//効果音
				SE(0);

				//たこ焼きのリセット
				Tako_Riset(tako,num);
				$gameVariables.setValue(15,$gameVariables.value(15) + 1);
			}
		}
	}

	//たこ焼きの出現
	function Tako_Go(num)
	{
		
		if(count % tako[num].timing == 0)
		{
			//効果音
			SE(2);
			tako[num].act = true;
		}
	}

	//たこ焼きの移動
	function Tako_Move()
	{
		for(var i = 0 ; i < tako_num ; i++)
		{
			//たこ焼きのフラグをタイミングで上げる
			Tako_Go(i);

			if(tako[i].act)
			{
				tako[i].y += tako_spd;

				//たこ焼き接触で取得
				Tako_Attack(tako,i);
			
				if(tako[i].y >= 688)
				{
					Tako_Riset(tako,i)
				}
			}
		}
	}

	///////////////////////////////////////////////////////////////

	var _Game_Interpreter_pluginCommand = Game_Interpreter.prototype.pluginCommand;

	Game_Interpreter.prototype.pluginCommand = function(command,args)
	{
		_Game_Interpreter_pluginCommand.call(this,command,args);

		if(command === 'Tako_Fell'){

			switch (args[0]){

			case 'main':
				$gameSystem.mainTako_Fell();
				break;		
			case 'set':
				$gameSystem.setTako_Fell();
				break;		
			case 'end':
				$gameSystem.endTako_Fell();
				break;		
			}
		}

	};
		

	//セットメインメソット
	Game_System.prototype.setTako_Fell = function()
	{
		Riset();

	}

	//ゲームメインメソット
	Game_System.prototype.mainTako_Fell = function()
	{

		count += 1;
		
		//操作
		Basketa_Move();

		//たこ焼きの移動
		Tako_Move();
				
		//表示
		Pix_Tako();
		Pix_Baskate();
		Pix_Bar();

	};

	//エンドメソット
	Game_System.prototype.endTako_Fell = function()
	{
		$gameScreen.clearPictures();
	}





})();
